mod cuda {
    use std::os::raw::c_int;

    use libc::size_t;

    #[link(name = "test", kind = "static")]
    extern {
        fn mulAll(out: *const c_int, input: *const c_int, n: c_int, size: size_t);
    }

    pub fn mul_by(src: &[i32], by: i32) -> Vec<i32> {
        unsafe {
            let len = src.len() as size_t;
            let psrc = src.as_ptr();

            let mut res = Vec::with_capacity(src.len());
            let pres = res.as_mut_ptr();

            mulAll(pres, psrc, by as c_int, len);

            // Turns out converting to a raw pointer drops the length information.
            res.set_len(src.len());
            res
        }
    }
}

fn main() {
    let v = (1..128).collect::<Vec<_>>();
    let n = 3;

    let o = cuda::mul_by(&v, n);
    assert_eq!(o, v.iter().map(|i| i * n).collect::<Vec<_>>(), "output mangled somewhere");
}
